// hier Package-Definitioneinfuegen, z.B. package syntax;


import java.net.*;
import java.io.*;
/**
 * socket class for SyntaxDiagnose using socket 4711
 */
public class SyntaxSocket
{

//this.explanation1 ="Tip: Hocker ist Maskulinum";
		//this.explanation2 ="Es heit richtig: \"der\" Hocker";

 
    /**
     * creates a ServerSocket with socket # 4711 and a SyntaxDiagnose object
     */   
    public SyntaxSocket() throws IOException {
	_diag = new SyntaxDiagnoseImpl();
	_socket = new ServerSocket(4711);
	
    }
    
    /**
     * creates a new SyntaxSocket and waits for client input
     * accepts only 1 client at a time
     * exit this program by sending "shutdown"
     */
    public static void main(String[] args) throws IOException {

	_syntax = new SyntaxSocket();
	System.out.println("Server started!");
	PrintWriter out;
	BufferedReader in;
	String inputLine="";
	String outputLine="";

	while(true)
	    {
		// wait for new client
		_clientSocket=_socket.accept();
		System.out.println("incoming!");	

		// initialize I/O streams
		out = new PrintWriter(_clientSocket.getOutputStream(), true);
		in = new BufferedReader(new InputStreamReader(_clientSocket.getInputStream()));
		
		// initiate conversation with client
		
		out.println("okeydokey!");
		
		// react on client input until client exits
		while ((inputLine = in.readLine()) != null) {
		    String reply = analyze(inputLine);    
		    out.println(reply);
		    // if client sends "shutdown", exit program
		     if (inputLine.equals("shutdown")) {
			 System.exit(0);
		     }
		}
	    }
    }

    /**
     * calls the SyntaxDiagnose interface and
     * creates a String representation of the diagnosis
     * @param sentence user input to be analyzed
     * @return String representation of the diagnosis result
     */
    private static synchronized String analyze(String sentence)
    {
	SyntaxDiagnose diag = new SyntaxDiagnoseImpl();
	Explanation explanation = new Explanation();
	Object[] violations;

	String reply ="[User Input: "+sentence +"]"; 
	diag.analyze(sentence);
	reply = reply + "[korrekt?  "+diag.isCorrect() +"]";

	if (!diag.isCorrect())
	    {
		explanation = diag.explanation();
		violations = explanation.getViolations();
		reply = reply + "[Number of Violations: "+violations.length+"]";
		
		for(int i=0;i<violations.length;i++)
		    {
			reply = reply + "[Violation: "+(String) violations[i]+"]";
		    }
	    }
	
	reply = reply + "[quality: "+diag.quality() +"]";
	reply = reply + "["+diag.syntaxTree().toString()+"]";
	return reply;
    }

    

    private static ServerSocket _socket;
    private SyntaxDiagnose _diag;
    private static SyntaxSocket _syntax;
    private static Socket _clientSocket = null;
}
